;---------------------------------------;
;    DDraw Landscape                    ;
;---------------------------------------;

TITLE WIN32ASM EXAMPLE
	.686p
      .MODEL FLAT, STDCALL
	option casemap :none
      .xmm

;-----------------------------------------------------------;
;                WIN32ASM / DDRAW SSE experimental engine   ;
;-----------------------------------------------------------;
      INCLUDE \masm32\include\windows.inc
	;INCLUDE \masm32\include\gdi32.inc
	;INCLUDE \masm32\include\kernel32.inc
	INCLUDE \masm32\include\user32.inc
	INCLUDE \masm32\SSE\ddraw.inc

	;INCLUDELIB \masm32\lib\gdi32.lib
	;INCLUDELIB \masm32\lib\kernel32.lib
	INCLUDELIB \masm32\lib\user32.lib
	INCLUDELIB \masm32\lib\ddraw.lib

	WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	
RETURN	MACRO	arg
	IFNB <arg>
		mov		eax, arg
	ENDIF
	ret
ENDM

LRETURN	MACRO	arg 
	IFNB <arg>
		mov		eax, arg
	ENDIF
	leave
	ret
ENDM

.DATA?
hWnd			HWND				?		; surface window
lpDD			LPDIRECTDRAW		?		; DDraw object
lpDDSPrimary	LPDIRECTDRAWSURFACE	?		; DDraw primary surface
ddsd			DDSURFACEDESC		<?>		; DDraw surface descriptor
ddscaps			DDSCAPS				<?>		; DDraw capabilities

palette			dd					256 dup (?)
table			dd					512 dup (?)
ALIGN 16
sintab            dd 8096 dup (?)
buffer            dd                            65536 dup (?)
                  
lpDDPalette		dd					?

.DATA
ALIGN 16
xd              REAL4 0.0,0.0,0.0,0.0
xd2             REAL4 0.01,0.01,0.01,0.01
xdmul1          REAL4 255.0,255.0,255.0,255.0
mask23          dd 07FFFFFh,07FFFFFh,07FFFFFh,07FFFFFh
xxyy            dq 0,0,0,0
xinc            dq 1,0
yinc            dq 0,1
ymask           dq 0,0FFFFh
fincrem           REAL8 0.000314159

cnt1              dd 0
scale            dd 512
;zero                    EQU             0
TIMER_ID1_SEC           EQU 1
ddwidth			EQU				1680		; display mode width
ddheight		EQU					1050		; display mode height
ddbpp			EQU					32		; display mode color depth

szClassName		db					"S", 0	; class name
szDisplayName	EQU					<szClassName>			; window name

wc				WNDCLASSEX			< sizeof WNDCLASSEX, CS_HREDRAW or CS_VREDRAW, offset WndProc, 0, 0, , 0, 0, , 0, offset szClassName, 0 >
c1              dd 600
c2              dd 0
fc1             REAL4 0.0
fc2             REAL4 0.0

.CODE
start:
     call init
	;INVOKE	GetModuleHandle, NULL
	INVOKE	WinMain, eax, NULL, NULL, SW_SHOWDEFAULT
	;INVOKE	ExitProcess, eax
init PROC
    finit
    mov ecx,8095
    xor eax,eax
    fldz
    fstp fc1
@@l1:fld fc1
     fld fc1
     fsin
     fimul scale
     fistp [sintab][eax]
     fadd fincrem
     fstp fc1
     add eax,4
     dec ecx
     jne @@l1
       
    
    ret
init ENDP



;-----------------------------------------------------------;
;                WinMain  ( entry point )                   ;
;-----------------------------------------------------------;

WinMain		PROC	hInst     :DWORD,
					hPrevInst :DWORD,
					CmdLine   :DWORD,
					CmdShow   :DWORD

	LOCAL msg  :MSG
	mov		eax, [hInst]
	mov		[wc.hInstance], eax
	;INVOKE	GetStockObject, BLACK_BRUSH
	mov eax,NULL ;to get rid of need to include gdi stuff
      mov		[wc.hbrBackground], eax

	INVOKE	RegisterClassEx, ADDR wc

; Create window at following size

	INVOKE	CreateWindowEx, 0, ADDR szClassName, ADDR szDisplayName, WS_POPUP, 0, 0, ddwidth, ddheight, NULL, NULL, hInst, NULL
	mov		[hWnd], eax

	INVOKE SetFocus, hWnd
	;rem INVOKE	ShowCursor, 0

; Initialize display

	INVOKE	DirectDrawCreate, NULL, ADDR lpDD, NULL
	DDINVOKE	SetCooperativeLevel, lpDD, hWnd, DDSCL_NORMAL or DDSCL_NOWINDOWCHANGES ; DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN
	; DDINVOKE	SetDisplayMode, lpDD, ddwidth, ddheight, ddbpp
	
	mov		[ddsd.dwSize], sizeof DDSURFACEDESC
	mov		[ddsd.dwFlags], DDSD_CAPS
	mov		[ddsd.ddsCaps.dwCaps], DDSCAPS_PRIMARYSURFACE
	DDINVOKE	CreateSurface, lpDD, ADDR ddsd, ADDR lpDDSPrimary, NULL
	
	INVOKE	ShowWindow, hWnd, CmdShow
      INVOKE SetTimer,hWnd,TIMER_ID1_SEC,10,NULL
              

; Loop until PostQuitMessage is sent

	.WHILE 1

		INVOKE	PeekMessage, ADDR msg, NULL, 0, 0, PM_REMOVE
            
		.IF eax != 0
			.IF msg.message == WM_QUIT
				INVOKE	PostQuitMessage, msg.wParam
				.BREAK
			.ELSE
				INVOKE	TranslateMessage, ADDR msg
				INVOKE	DispatchMessage, ADDR msg
			.ENDIF
		.ELSE
.ENDIF
	.ENDW
LRETURN	msg.wParam
WinMain		ENDP


			;INVOKE	GetFocus

			;.IF eax == hWnd
                           renderc PROC
                           pushad

				mov		[ddsd.dwSize], sizeof DDSURFACEDESC
				mov		[ddsd.dwFlags], DDSD_PITCH

				;.WHILE 1
                              DDSINVOKE	mLock, lpDDSPrimary, NULL, ADDR ddsd, DDLOCK_WAIT, NULL
                              ;DDINVOKE WaitForVerticalBlank, lpDD, DDWAITVB_BLOCKBEGIN, NULL
                              ;,db 0cch
                              pxor mm1,mm1
                              movaps xmm0,xd
                              movaps xmm1,xd2
                              mov ebx,ddsd.lpSurface
                              mov edx,0
                              @l2:
                              mov ecx,0
                              push ebx
                              @l1:
                              movaps xmm2,xmm0
                              ;mov xxyy,ecx
                              ;mov [xxyy+4],edx
                              ;movq mm1,xxyy
                              CVTPI2PS xmm7,mm1
                              mulps xmm7,xmm7
                              MOVHLPS xmm6,xmm7
                              addps xmm7,xmm6
                              sqrtps xmm7,xmm7 
                              mulps xmm2,xdmul1
                              mulps xmm2,xmm7
                              
                              ;CVTPS2PI mm0,xmm2
                              ;movq [ebx],mm0
                              andps xmm2,mask23
                              movaps [ebx],xmm2
                              addps xmm0,xmm1
                              add ebx,16
                              paddd mm1,xinc
                              inc ecx
                              cmp ecx,200 ;839
                              jne @l1
                              pop ebx
                              add ebx,ddsd.lPitch
                              ;movaps xmm0,xd
                              pand mm1,ymask
                              paddd mm1,yinc
                              inc edx
                              cmp edx,500 ;1023
                              jne @l2
                                
                                




					;.BREAK .IF eax == DD_OK

					;.IF eax == DDERR_SURFACELOST
					;	DDSINVOKE	Restore, lpDDSPrimary
					;.ELSE
						;FATAL "Couldn't lock surface"
					;.ENDIF
				;.ENDW

				

				;call	render
                        EMMS
				DDSINVOKE	Unlock, lpDDSPrimary, ddsd.lpSurface
                        popad
                        ret
                        

                        renderc ENDP

			;.ENDIF
		
;.ENDIF
;	.ENDW
	INVOKE DestroyWindow, hWnd
	;rem.IF lpDD != NULL
	;rem	.IF lpDDSPrimary != NULL
	;rem		DDSINVOKE	Release, lpDDSPrimary
	;rem		mov		[lpDDSPrimary], NULL
	;rem	.ENDIF
      ;rem  
	;rem	DDINVOKE	Release, lpDD
	;rem	mov		[lpDD], NULL

	;rem.ENDIF

;LRETURN	msg.wParam
;WinMain		ENDP


;-----------------------------------------------------------;
;             Window Proc  ( handle events )                ;
;-----------------------------------------------------------;

WndProc		PROC	hWin   :DWORD,
					uMsg   :DWORD,
					wParam :DWORD,
					lParam :DWORD
        .IF uMsg==WM_TIMER
        call renderc
        RETURN 0
        .ENDIF
	   .IF uMsg == WM_KEYDOWN
		.IF wParam == VK_ESCAPE
			INVOKE	PostQuitMessage, NULL
			RETURN	0 
	   .ENDIF
      ;.ELSEIF uMsg == WM_DESTROY
	;	INVOKE	PostQuitMessage, NULL
	;	RETURN	0 
	.ENDIF

	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam

	ret
WndProc		ENDP

END start

